package matsubara.carcontroller;

/**
 * <p>^Cg: sgrV~[^</p>
 * <p>: vEX̃nCubhVXeisgrj̐SAVԋ@\̃V~[V</p>
 * <p>쌠: Copyright (c) 2001</p>
 * <p>Ж: </p>
 * @author a
 * @version 1.0.0
 */

import matsubara.gear.*;



public class ThsController extends CarController {
  PlanetaryGear m_planetaryGear;
  boolean m_bGasoline;
  boolean m_bMotor;
  boolean m_bKaisei;

  //  THS 샂[h
  public static final int thsStop = 0;      //  GlM[̗Ȃ
  public static final int thsStart = 1;     //  [^[݂̂Ŕi
  public static final int thsNormal = 2;    //  ʏ^]
  public static final int thsNormalOD = 3;  //  ʏ^](I[o[hCuE[^[Ɣd@̖t])
  public static final int thsFullAccel = 4; //  SJiGW+[^[j
  public static final int thsKaisei = 5;    //  񐶃u[L
  public static final int thsKaiseiAndEngine = 6; //  񐶃u[L{GW͔d@ׂ̕œĂ
  int m_nThsMode = thsStop;

  public ThsController(int nPlanetaryGearX, int nPlanetaryGearY, int nPlanetaryGearSize) {
    super();
    m_planetaryGear = new PlanetaryGear(nPlanetaryGearX, nPlanetaryGearY, nPlanetaryGearSize, 30, 23, 78, 4); //  ͕@\
  }

  protected void driveInternal(double rMilliSec, int nAccel, int nBrake) {
    String sShiftPosition = getShiftPosition();
    if (sShiftPosition.equals("D"))
      driveInternal_D_B(rMilliSec, nAccel, nBrake);
    else if (sShiftPosition.equals("B"))
      driveInternal_D_B(rMilliSec, nAccel, nBrake);
    else if (sShiftPosition.equals("R"))
      driveInternal_R(rMilliSec, nAccel, nBrake);
    else if (sShiftPosition.equals("P"))
      driveInternal_P(rMilliSec, nAccel, nBrake);
    else
      driveInternal_N(rMilliSec, nAccel, nBrake);     //  N W

    m_bMotor = (m_nThsMode == thsStart) || (m_nThsMode == thsFullAccel);
    m_bKaisei = (m_nThsMode == thsKaisei) || (m_nThsMode == thsKaiseiAndEngine);
    m_bGasoline = (m_nThsMode == thsFullAccel) || (m_nThsMode == thsNormal) || (m_nThsMode == thsNormalOD) || ((m_nThsMode == thsStop) && (getEngineRpm() >= 1000));
  }

  private void driveInternal_P(double rMilliSec, int nAccel, int nBrake) {
    m_nThsMode = thsStop;

    //  sgrel
    double rEngineRpm = m_planetaryGear.getPlaCarrierSpeed();
    //  sgreڕWl
    double rTargetEngineRpm = 0;

    //  GW̏
    if (nAccel >= 5) {
      //  GWR
      rTargetEngineRpm = 1000 + nAccel * 500 / 100 ;
    }

    if (rEngineRpm < rTargetEngineRpm) {
      rEngineRpm += (rMilliSec / 1000) * 2000;  //  b2000]]グi\zj
      if (rEngineRpm > rTargetEngineRpm)
        rEngineRpm = rTargetEngineRpm;
    }
    else if (rEngineRpm > rTargetEngineRpm) {
      rEngineRpm -= (rMilliSec / 1000) * 4000;  //  b4000]]i\zj
      if (rEngineRpm < rTargetEngineRpm)
        rEngineRpm = rTargetEngineRpm;
    }

    m_planetaryGear.setRingGearSpeed(0);
    m_planetaryGear.setPlaCarrierSpeed(rEngineRpm);
    m_planetaryGear.move(rMilliSec / 100);
  }

  private void driveInternal_R(double rMilliSec, int nAccel, int nBrake) {
    m_nThsMode = thsStop;

    //  sgrel
    double rSpeed = getSpeed();
    double rEngineRpm = m_planetaryGear.getPlaCarrierSpeed();

    //  sgreڕWl
    double rTargetSpeed = - 13 - (double)(nAccel * 27 / 100);
    double rTargetEngineRpm = 0;

    //  EŘvZ
    if (rSpeed > rTargetSpeed) {
      //  ̌vZ
      rSpeed += (rTargetSpeed - rSpeed) * rMilliSec / 1000 * 0.15;
      if (rSpeed < rTargetSpeed)
        rSpeed = rTargetSpeed;
      m_bMotor = true;
      m_nThsMode = thsStart;
    }
    else {
      rSpeed += 2.20 * rMilliSec / 1000;

      if (rSpeed > rTargetSpeed)
        rSpeed = rTargetSpeed;
      if (rSpeed < -10) {
        m_nThsMode = thsKaisei;
      }
    }

    //  u[L̔f
    if (isParkingBrake() && nBrake < 50)
      nBrake = 50;  //  p[LOu[L𕁒ʂ̃u[L50%Ƃ݂ȂB
    if (nBrake > 5) {
      rSpeed += 0.25 * nBrake * rMilliSec / 1000;
      if (rSpeed > 0)
        rSpeed = 0;
      if (rSpeed < -10)
        m_nThsMode = thsKaisei;
      else
        m_nThsMode = thsStop;
    }

    double rTyreDiameter = 165 * 0.65 * 2 + 15 * 25.4;
    double rTyreGirth = rTyreDiameter * Math.PI;
    double rRingGear = (int)((3.927 / rTyreDiameter / Math.PI / 60 * 1000 * 1000) * rSpeed);

    m_planetaryGear.setRingGearSpeed(rRingGear);
    m_planetaryGear.setPlaCarrierSpeed(rEngineRpm);
    m_planetaryGear.move(rMilliSec / 100);
  }

  private void driveInternal_N(double rMilliSec, int nAccel, int nBrake) {
    m_planetaryGear.move(rMilliSec / 100);
    m_nThsMode = thsStop;
  }

  private void driveInternal_D_B(double rMilliSec, int nAccel, int nBrake) {
    //  sgrel
    double rSpeed = getSpeed();
    double rEngineRpm = m_planetaryGear.getPlaCarrierSpeed();

    //  sgreڕWl
    double rTargetSpeed = 13 + nAccel * 1.5;
    double rTargetEngineRpm = 0;

    //  GW̏
    if ((rSpeed >= 45 || rSpeed < rTargetSpeed - 20) && nAccel >= 10) {
      //  GWR
      rTargetEngineRpm = 1150 + (rTargetSpeed - 40) * (rTargetSpeed - 40) * 2850 / 10000 ;
      if (rTargetEngineRpm > 4000)
        rTargetEngineRpm = 4000;
      if (rEngineRpm >= 1000)
        m_nThsMode = thsNormal;
      else
        m_nThsMode = thsStart;
    }
    else if (rSpeed >= 3 && rSpeed < 15 && rEngineRpm >= 1000) {
      rTargetEngineRpm = 1150;
      m_nThsMode = thsNormal;
    }
    else {
      //  GW͔d@ɂĉ񂳂Ă邩A܂͎~܂ĂiRĂĂȂj
      rTargetEngineRpm = 1000 + (rSpeed - 50) * 10;
      if (rSpeed < 45)
        rTargetEngineRpm = 0;
      m_nThsMode = thsStart;
    }

    if (rEngineRpm < rTargetEngineRpm) {
      rEngineRpm += (rMilliSec / 1000) * 2000;  //  b2000]]グi\zj
      if (rEngineRpm > rTargetEngineRpm)
        rEngineRpm = rTargetEngineRpm;
    }
    else if (rEngineRpm > rTargetEngineRpm) {
      rEngineRpm -= (rMilliSec / 1000) * 4000;  //  b4000]]i\zj
      if (rEngineRpm < rTargetEngineRpm)
        rEngineRpm = rTargetEngineRpm;
    }
    //  EŘvZ
    if (rSpeed < rTargetSpeed) {
      //  ̌vZ
      double rMaxPowerRatio = 0.5 + (160 - rSpeed) / 320;
      if (getShiftPosition().equals("D"))
        rSpeed += Math.pow(rTargetSpeed - rSpeed, 0.9) * rMilliSec / 1000 * 0.135 * rMaxPowerRatio; //  D W̉
      else
        rSpeed += Math.pow(rTargetSpeed - rSpeed, 0.9) * rMilliSec / 1000 * 0.129 * rMaxPowerRatio; //  B W̉

      if (rSpeed > rTargetSpeed)
        rSpeed = rTargetSpeed;
      if ((rSpeed < rTargetSpeed - 15) || (rTargetSpeed >= 140) || (rEngineRpm == 0)) {
        if (rEngineRpm >= 1000)
          m_nThsMode = thsFullAccel;
        else
          m_nThsMode = thsStart;
      }
    }
    else {
      //  R
      double rBrakeRatio = 1.0; //  cŴƂ̎R̊Ƃ̔r
      if (getShiftPosition().equals("B"))
        rBrakeRatio = 1.4;  //  aW̔䗦
      rSpeed -= (1.4 + rSpeed / 100 * 1.5) * rMilliSec / 1000 * rBrakeRatio;
      if (rSpeed < rTargetSpeed)
        rSpeed = rTargetSpeed;
      if ((nAccel == 0) && (rSpeed > 15))
          m_nThsMode = thsKaisei;
      m_nThsMode = thsKaisei;
    }

    //  u[L̔f
    if (isParkingBrake() && nBrake < 50)
      nBrake = 50;  //  p[LOu[L𕁒ʂ̃u[L50%Ƃ݂ȂB
    if (nBrake > 5) {
      rSpeed -= (0.20 + rSpeed / 100 * 0.8) * nBrake * rMilliSec / 1000;
      if (rSpeed < 0)
        rSpeed = 0;
      if (rSpeed > 10)
        m_nThsMode = thsKaisei;
      else
        m_nThsMode = thsStop;
    }
    if ((m_nThsMode == thsKaisei) && (rTargetEngineRpm > 0))
      m_nThsMode = thsKaiseiAndEngine;

    double rTyreDiameter = 165 * 0.65 * 2 + 15 * 25.4;
    double rTyreGirth = rTyreDiameter * Math.PI;
    double rRingGear = (int)((3.927 / rTyreDiameter / Math.PI / 60 * 1000 * 1000) * rSpeed);

    m_planetaryGear.setRingGearSpeed(rRingGear);
    m_planetaryGear.setPlaCarrierSpeed(rEngineRpm);

    //  d@̉]ɒ[ɂȂȂ悤ɃGW̉]𒲐
    if (m_planetaryGear.getSunGearSpeed() > 6000)
      m_planetaryGear.setSunGearSpeed(6000);
    else if (m_planetaryGear.getSunGearSpeed() < -4500)
      m_planetaryGear.setSunGearSpeed(-4500);
    if ((m_nThsMode == thsNormal) && (m_planetaryGear.getSunGearSpeed() < 500))
      m_nThsMode = thsNormalOD;   //  d@ 500rpm ŔdiƉ肷ĵƂAI[o[hCuԂłƂ݂ȂB
    m_planetaryGear.move(rMilliSec / 100);
  }

  public double getEngineRpm() {
    return m_planetaryGear.getPlaCarrierSpeed();
  }
  public double getSpeed() {
    double rTyreDiameter = 165 * 0.65 * 2 + 15 * 25.4;
    double rTyreGirth = rTyreDiameter * Math.PI;
    return (m_planetaryGear.getRingGearSpeed() / 3.927 * rTyreDiameter * Math.PI * 60 / 1000 / 1000);
  }

  public PlanetaryGear getPlanetaryGear() {
    return m_planetaryGear;
  }

  public int getThsMode() {
    return m_nThsMode;
  }

  public boolean isGasoline() {
    return m_bGasoline;
  }
  public boolean isMotor() {
    return m_bMotor;
  }
  public boolean isKaisei() {
    return m_bKaisei;
  }

  public Gear getRingGear() {
    return m_planetaryGear.getRingGear();
  }
  public PlanetaryCarrier getPlanetaryCarrier() {
    return m_planetaryGear.getPlanetaryCarrier();
  }
  public Gear getSunGear() {
    return m_planetaryGear.getSunGear();
  }

  public double getRingGearSpeed() {
    return m_planetaryGear.getRingGearSpeed();
  }
  public double getPlaCarrierSpeed() {
    return m_planetaryGear.getPlaCarrierSpeed();
  }
  public double getSunGearSpeed() {
    return m_planetaryGear.getSunGearSpeed();
  }
}