package matsubara.gear;

import java.awt.Color;
import java.awt.Graphics;

/**
 * ^Cg:  Planetary Gear
 * :    vl^MApėpNX
 * 쌠:   Copyright (c) 2001
 * Ж:
 * @author a
 * @version 1.0
 */

class EPlanetaryGear extends Error {
  EPlanetaryGear(String sMessage) {
    super(sMessage);
  }
}

public class PlanetaryGear extends GearBase {
  Gear             m_ringGear = new Gear();
  Gear             m_piniGear1  = new Gear();
  Gear             m_piniGear2 = new Gear();
  Gear             m_piniGear3 = new Gear();
  Gear             m_piniGear4 = new Gear();
  PlanetaryCarrier m_plaCarrier = new PlanetaryCarrier();
  Gear             m_sunGear = new Gear();

  double m_rRingGearSpeed = 0;
  double m_rPlaCarrierSpeed = 0;

  public PlanetaryGear(int nX, int nY, int nSize, int nSunGear, int nPinionGear, int nRingGear, int nGearDepth) {
    double rPinionGearSize = (nRingGear - nSunGear) / 2 * nSize / nRingGear;
    double rPlanetaryCarrierSize = nSunGear * nSize / nRingGear + rPinionGearSize;

    if (rPinionGearSize * 2 + nGearDepth >= 2 * rPlanetaryCarrierSize * Math.sin(Math.PI / 4))
      throw new EPlanetaryGear("sjIMAmԂ荇܂B");
    if ((nRingGear + nSunGear) % 4 != 0)
      throw new EPlanetaryGear("Ԃݍ܂B");

    m_ringGear   = new RingGear(        nX, nY, nRingGear * nSize / nRingGear,   nRingGear, nGearDepth);
    m_piniGear1  = new Gear(            nX, nY, rPinionGearSize, nPinionGear, nGearDepth);
    m_piniGear2  = new Gear(            nX, nY, rPinionGearSize, nPinionGear, nGearDepth);
    m_piniGear3  = new Gear(            nX, nY, rPinionGearSize, nPinionGear, nGearDepth);
    m_piniGear4  = new Gear(            nX, nY, rPinionGearSize, nPinionGear, nGearDepth);
    m_sunGear    = new Gear(            nX, nY, nSunGear * nSize / nRingGear   , nSunGear   , nGearDepth);
    m_plaCarrier = new PlanetaryCarrier(nX, nY, (int)rPlanetaryCarrierSize);

    move(0);  //  sjIMÄʒu𐳂ʒuɔzu邽

    //  sjIMA̐F
    m_piniGear1.setColor1(Color.orange);
    m_piniGear1.setColor2(Color.darkGray);
    m_piniGear2.setColor1(Color.orange);
    m_piniGear2.setColor2(Color.darkGray);
    m_piniGear3.setColor1(Color.orange);
    m_piniGear3.setColor2(Color.darkGray);
    m_piniGear4.setColor1(Color.orange);
    m_piniGear4.setColor2(Color.darkGray);
    //  vl^LA̐F
    m_plaCarrier.setColor2(Color.red);
    //  TMA̐F
    m_sunGear.setColor2(Color.blue);
    //  OMA̐F
    m_ringGear.setColor2(new Color(0, 0xbb, 0));

    m_plaCarrier.setWidth((int)(m_piniGear1.getSize()));

    //  eMAݍ悤ɔ
    m_piniGear1.setAngle((0 + 2) * Math.PI / 2);
    m_piniGear2.setAngle((1 + 2) * Math.PI / 2 - (2 * Math.PI / m_piniGear2.getGearCount() / 4 * (m_ringGear.getGearCount() % 4)));
    m_piniGear3.setAngle((2 + 2) * Math.PI / 2 + (2 * Math.PI / m_piniGear3.getGearCount() / 2 * (m_ringGear.getGearCount() % 2)));
    m_piniGear4.setAngle((3 + 2) * Math.PI / 2 + (2 * Math.PI / m_piniGear4.getGearCount() / 4 * (m_ringGear.getGearCount() % 4)));

    if (m_piniGear1.getGearCount() % 2 == 1)
      m_sunGear.setAngle(2 * Math.PI / (m_sunGear.getGearCount() * 2));
  }

  public void draw(Graphics g) {
    m_ringGear.draw(g);
    m_plaCarrier.draw(g);
    m_piniGear1.draw(g);
    m_piniGear2.draw(g);
    m_piniGear3.draw(g);
    m_piniGear4.draw(g);
    m_sunGear.draw(g);
  }

  //  ݒ肳ĂMAXs[hŎԂ]
  // d@]iGW]~iNMATCY{TMATCYj|[^[]~NMATCYjTMATCY
  public void move(double nMilliSec) {
    int nRingGearCount = m_ringGear.getGearCount();
    int nSunGearCount = m_sunGear.getGearCount();
    double rPinionGearSize = (m_ringGear.getSize() - m_sunGear.getSize()) / 2;
    double rPlanetaryCarrierSize = m_sunGear.getSize() + rPinionGearSize;
    double rSunGearSpeed = (m_rPlaCarrierSpeed * (nRingGearCount + nSunGearCount) - m_rRingGearSpeed * nRingGearCount) / (double)nSunGearCount;

    m_sunGear.setAngle(m_sunGear.getAngle() + rSunGearSpeed / 60 / 1000 * nMilliSec * 2 * Math.PI);
    m_plaCarrier.setAngle(m_plaCarrier.getAngle() + (double)m_rPlaCarrierSpeed / 60 / 1000 * nMilliSec * 2 * Math.PI);
    m_ringGear.setAngle(m_ringGear.getAngle() + (double)m_rRingGearSpeed / 60 / 1000 * nMilliSec * 2 * Math.PI);

    //  sjIMÄʒu]
    m_piniGear1.setPosX(m_plaCarrier.rotateX(rPlanetaryCarrierSize, 0));
    m_piniGear1.setPosY(m_plaCarrier.rotateY(rPlanetaryCarrierSize, 0));
    m_piniGear2.setPosX(m_plaCarrier.rotateX(rPlanetaryCarrierSize, Math.PI / 2));
    m_piniGear2.setPosY(m_plaCarrier.rotateY(rPlanetaryCarrierSize, Math.PI / 2));
    m_piniGear3.setPosX(m_plaCarrier.rotateX(rPlanetaryCarrierSize, Math.PI));
    m_piniGear3.setPosY(m_plaCarrier.rotateY(rPlanetaryCarrierSize, Math.PI));
    m_piniGear4.setPosX(m_plaCarrier.rotateX(rPlanetaryCarrierSize, Math.PI * 3 / 2));
    m_piniGear4.setPosY(m_plaCarrier.rotateY(rPlanetaryCarrierSize, Math.PI * 3 / 2));

    //  sjIMẢ]

    double rPinionGearSpeed = m_rPlaCarrierSpeed + ((double)m_rRingGearSpeed - m_rPlaCarrierSpeed) * m_ringGear.getGearCount() / m_piniGear1.getGearCount();
//    double rPinionGearSpeed = m_rPlaCarrierSpeed + ((double)m_rRingGearSpeed - m_rPlaCarrierSpeed) * m_ringGear.getSize() / nPinionGearSize;
    m_piniGear1.setAngle(m_piniGear1.getAngle() + rPinionGearSpeed / 60 / 1000 * nMilliSec * 2 * Math.PI);
    m_piniGear2.setAngle(m_piniGear2.getAngle() + rPinionGearSpeed / 60 / 1000 * nMilliSec * 2 * Math.PI);
    m_piniGear3.setAngle(m_piniGear3.getAngle() + rPinionGearSpeed / 60 / 1000 * nMilliSec * 2 * Math.PI);
    m_piniGear4.setAngle(m_piniGear4.getAngle() + rPinionGearSpeed / 60 / 1000 * nMilliSec * 2 * Math.PI);

  }

  public void setRingGearSpeed(double rRingGearSpeed) {
    m_rRingGearSpeed = rRingGearSpeed;
  }
  public double getRingGearSpeed() {
    return m_rRingGearSpeed;
  }
  public void setPlaCarrierSpeed(double rPlaCarrierSpeed) {
    m_rPlaCarrierSpeed = rPlaCarrierSpeed;
  }
  public double getPlaCarrierSpeed() {
    return m_rPlaCarrierSpeed;
  }
  public double getSunGearSpeed() {
    double rRingGearSize = m_ringGear.getSize();
    double rSunGearSize = m_sunGear.getSize();
    double rPinionGearSize = (rRingGearSize - rSunGearSize) / 2;
//    int nPlanetaryCarrierSize = nSunGearSize + nPinionGearSize;
    return (m_rPlaCarrierSpeed * (rRingGearSize + rSunGearSize) - m_rRingGearSpeed * rRingGearSize) / rSunGearSize;
  }
  public void setSunGearSpeed(double rSunGearSpeed) {
    double rRingGearSize = m_ringGear.getSize();
    double rSunGearSize = m_sunGear.getSize();
    double rPinionGearSize = (rRingGearSize - rSunGearSize) / 2;
//    int nPlanetaryCarrierSize = nSunGearSize + nPinionGearSize;

//    (nSunGearSpeed * nSunGearSize + m_rRingGearSpeed * nRingGearSize) / (nRingGearSize + nSunGearSize) = m_rPlaCarrierSpeed;

    setPlaCarrierSpeed((int)((rSunGearSpeed * rSunGearSize + m_rRingGearSpeed * rRingGearSize) / (rRingGearSize + rSunGearSize)));
  }
  public Gear getRingGear() {
    return m_ringGear;
  }
  public PlanetaryCarrier getPlanetaryCarrier() {
    return m_plaCarrier;
  }
  public Gear getSunGear() {
    return m_sunGear;
  }
}