package matsubara.graphics;

import java.awt.*;

/**
 * ^Cg:  Progress Line
 * :    i\郉CE]\邱Ƃo܂B
 * 쌠:   Copyright (c) 2001
 * Ж:
 * @author a
 * @version 1.0
 */

public class ProgressLine extends LineBase {
  int m_nPosition = 0;
  boolean m_bReverse = false;
  int m_nMarkSize = 0;

  public ProgressLine(int nStartX, int nStartY, int nEndX, int nEndY, Color color) {
    super(nStartX, nStartY, nEndX, nEndY, color);
  }
  public ProgressLine(int nStartX, int nStartY, int nEndX, int nEndY, Color color, int nMarkSize) {
    super(nStartX, nStartY, nEndX, nEndY, color);
    setMarkSize(nMarkSize);
  }

  public void draw(Graphics g) {
    /**@todo:  matsubara.arrow.ArrowBase abstract \bh*/
    drawArrow(g);
    int nX, nY;
    if (isReverse() == false) {
      nX = getStartX() + (getEndX() - getStartX()) * getPosition() / 100;
      nY = getStartY() + (getEndY() - getStartY()) * getPosition() / 100;
    }
    else {
      nX = getStartX() + (getEndX() - getStartX()) * (100 - getPosition()) / 100;
      nY = getStartY() + (getEndY() - getStartY()) * (100 - getPosition()) / 100;
    }
    g.setColor(Color.white);
    g.fillArc(nX - m_nMarkSize / 2, nY - m_nMarkSize / 2, m_nMarkSize, m_nMarkSize, 0, 360);
  }

  public void setPosition(int nPosition) {
    m_nPosition = nPosition % 100;
  }
  int  getPosition() {
    return m_nPosition;
  }
  public void movePosition(int n) {
    m_nPosition = (m_nPosition + n) % 100;
    if (m_nPosition < 0)
      m_nPosition += 100;
  }
  public void setReverse(boolean bReverse) {
    m_bReverse = bReverse;
  }
  public boolean isReverse() {
    return m_bReverse;
  }
  public int getMarkSize() {
    return m_nMarkSize;
  }
  public void setMarkSize(int nMarkSize) {
    m_nMarkSize = nMarkSize;
  }
}